VERSION 1.0 CLASS

BEGIN

  MultiUse = -1  'True

END

Attribute VB_Name = "clsColorButton"
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'************************************************************
'NXFclsColorButton
'NX̐FJ[{^
'쐬ҁF
'쐬F2004/11/27
'o[WF1.2 'ColorIndex=0ɂƂA{^ɘg悤ɏC
'o[WF1.3 'ColorIndex=1-56ɂƂɁAANeBu[NubN擾łȂƂ
'                   Ӑ}IɃG[𔭐悤ɏC
'                'Add\bhsƂ̏ǉ
'************************************************************
Option Explicit 'Öق̌^錾̋֎~

Private WithEvents lblColorButton As msforms.Label
Private WithEvents lblColorButtonEffect As msforms.Label

Private m_Parent As Object          '̃Rg[̃IuWFNg\tAReiNX̃IuWFNgL܂
Private m_IsExistObject As Boolean  'Add\bhĂ΂ꂽォL
Private m_Locked As Boolean
Private m_ColorIndex As Long

Private Const m_Distance As Single = 3

'************************************************************
'\bhFAdd
'\bh̐FRg[\t
'inF
'       ContainerClassObject:̃Rg[\tReiIuWFNg
'                               ̓Iɂ͈ȉ̃NX̃IuWFNgłB
'                               [U[tH[At[Ay[W
'                               ifUCɁAIuWFNg̓
'                               Obh\́j
'       LeftFxW
'       TopFyW
'       HeightF
'       WidthF
'       CaptionF{^ɕ\镶
'       ColorIndexF{^̐F(0œ)
'       ValueF{^ς݂ǂ
'       ControlTipTextF}EX̂Ƃɕ\镶
'       Locked:bN邩ǂ
'outFȂ
'ԂlFȂ
'X[G[F
'       AddĂꍇ
'       Ŏw肳vpeBlsłꍇ
'       G[NꍇAIuWFNgContainerClassObject
'       ɓ\t܂
'쐬ҁF
'쐬F2004/11/9
'************************************************************
Public Sub Add(ByVal ContainerClassObject As Object, _
    Optional ByVal Left As Single = 0, _
    Optional ByVal Top As Single = 0, _
    Optional ByVal Height As Single = 21, _
    Optional ByVal Width As Single = 21, _
    Optional ByRef Caption As String = "", _
    Optional ByVal ColorIndex As Long = 0, _
    Optional ByVal Value As Boolean = False, _
    Optional ByRef ControlTipText As String = "", _
    Optional ByRef Locked As Boolean = False)

    If m_IsExistObject Then
        Err.Raise 1000, , "Add邱Ƃ͏o܂łB"
    End If
    If Height < m_Distance * 2 Then
        Err.Raise 380, , "HeightvpeB̒l" & Format(m_Distance * 2) & "ȏw肵ĉB"
    End If
    If Width < m_Distance * 2 Then
        Err.Raise 380, , "WidthvpeB̒l" & Format(m_Distance * 2) & "ȏw肵ĉB"
    End If
    If ColorIndex < 0 Or ColorIndex > 56 Then
        Err.Raise 380
    End If
    
    'thisControlɃIuWFNg\t
    With ContainerClassObject.Controls
        Set lblColorButtonEffect = .Add("Forms.Label.1")
        Set lblColorButton = .Add("Forms.Label.1")
    End With
    
    Set m_Parent = ContainerClassObject
    m_IsExistObject = True
    
    On Error GoTo ErrHandlerAfterAdding 'ver1.3ǉ
        'thisControlɓ\tIuWFNg̃vpeBݒ肷
        With lblColorButton
            .Top = Top + m_Distance
            .Left = Left + m_Distance
            .Height = Height - m_Distance * 2
            .Width = Width - m_Distance * 2
            .TextAlign = fmTextAlignCenter '{^ɕ\镶𒆉ɂ
        End With
    
        With lblColorButtonEffect
            .Top = Top
            .Left = Left
            .Height = Height
            .Width = Width
            .BackStyle = fmBackStyleTransparent
        End With
        
        'Ŏw肳ꂽl
        '(ɂAevpeBPropertyLetvV[WĂяo܂)
        With Me
            .Caption = Caption
            .ColorIndex = ColorIndex
            .Value = Value
            .ControlTipText = ControlTipText
            .Locked = Locked
        End With
    On Error GoTo 0
    Exit Sub

ErrHandlerAfterAdding: 'ver1.3ǉ
    Me.Delete
    Call Err.Raise(Err.Number)
End Sub

'************************************************************
'\bhFDelete
'\bh̐FRg[폜
'inFȂ
'outFȂ
'ԂlFȂ
'X[G[F
'쐬ҁF
'쐬F2004/11/9
'************************************************************
Public Sub Delete()
    If Not m_IsExistObject Then Exit Sub
    
    'Add\bhthisControlɓ\tIuWFNg폜܂
    m_Parent.Controls.Remove (lblColorButton.Name)
    m_Parent.Controls.Remove (lblColorButtonEffect.Name)
    Set lblColorButton = Nothing
    Set lblColorButtonEffect = Nothing
    
    '̃Rg[̃IuWFNg\tAReiNX̃IuWFNgւ̎QƂ폜܂
    Set m_Parent = Nothing
    
    m_IsExistObject = False
    
End Sub

'************************************************************
'\bhFClass_Initialize
'\bh̐FW[XR[vϐ̏
'inFȂ
'outFȂ
'ԂlFȂ
'X[G[FȂ
'쐬ҁF
'쐬F2004/10/24
'************************************************************
Private Sub Class_Initialize()
    m_IsExistObject = False
End Sub

'************************************************************
'\bhFClass_Terminate
'\bh̐F
'inFȂ
'outFȂ
'ԂlFȂ
'X[G[FȂ
'쐬ҁF
'쐬F2004/10/24
'************************************************************
Private Sub Class_Terminate()
    Call Me.Delete
End Sub

'************************************************************
'vpeBFTop
'vpeB̐FRg[yW
'X[G[F
'쐬ҁF
'쐬F2004/11/9
'************************************************************
Public Property Get Top() As Single
    Top = lblColorButtonEffect.Top
End Property

Public Property Let Top(ByVal sNewValue As Single)
    lblColorButtonEffect.Top = sNewValue
    lblColorButton.Top = sNewValue + m_Distance
End Property

'************************************************************
'vpeBFLeft
'vpeB̐FRg[xW
'X[G[F
'쐬ҁF
'쐬F2004/11/9
'************************************************************
Public Property Get Left() As Single
    Left = lblColorButtonEffect.Left
End Property

Public Property Let Left(ByVal sNewValue As Single)
    lblColorButtonEffect.Left = sNewValue
    lblColorButton.Left = sNewValue + m_Distance
End Property

'************************************************************
'vpeBFWidth
'vpeB̐FRg[̎̕QƂƐݒ
'X[G[F
'            m_Distance * 2̒lݒ肵悤Ƃ(Err.Number=380)
'쐬ҁF
'쐬F2004/11/9
'************************************************************
Public Property Get Width() As Single
    Width = lblColorButtonEffect.Width
End Property

Public Property Let Width(ByVal sNewValue As Single)
    If sNewValue < m_Distance * 2 Then
        Call Err.Raise(380, "", "HeightvpeB̒l" & Format(m_Distance * 2) & "ȏw肵ĉB")
    End If
    lblColorButtonEffect.Width = sNewValue
    lblColorButton.Width = sNewValue - m_Distance * 2
End Property

'************************************************************
'vpeBFHeight
'vpeB̐FRg[̍̎QƂƐݒ
'X[G[F
'            m_Distance * 2̒lݒ肵悤Ƃ(Err.Number=380)
'쐬ҁF
'쐬F2004/11/9
'************************************************************
Public Property Get Height() As Single
    Height = lblColorButtonEffect.Height
End Property

Public Property Let Height(ByVal sNewValue As Single)
    If sNewValue < m_Distance * 2 Then
        Call Err.Raise(380, "", "HeightvpeB̒l" & Format(m_Distance * 2) & "ȏw肵ĉB")
    End If
    lblColorButtonEffect.Height = sNewValue
    lblColorButton.Height = sNewValue - m_Distance * 2
End Property

'************************************************************
'vpeBFValue
'vpeB̐FRg[ς݂ǂ̎QƂƐݒ
'X[G[F
'쐬ҁF
'쐬F2004/11/3
'************************************************************
Public Property Get Value() As Boolean
    If lblColorButtonEffect.SpecialEffect = 2 Then
        Value = True
    Else
        Value = False
    End If
End Property

Public Property Let Value(ByVal bNewValue As Boolean)
    If bNewValue Then
        lblColorButtonEffect.SpecialEffect = 2
    Else
        lblColorButtonEffect.SpecialEffect = 0
    End If
End Property

'************************************************************
'vpeBFLocked
'vpeB̐FRg[łValue̒lsςƂ邩
'X[G[F
'쐬ҁF
'쐬F2004/11/3
'************************************************************
Public Property Get Locked() As Boolean
    Locked = m_Locked
End Property

Public Property Let Locked(ByVal bNewValue As Boolean)
    m_Locked = bNewValue
End Property

'************************************************************
'vpeBFCaption
'vpeB̐F{^ɕ\镶
'X[G[F
'쐬ҁF
'쐬F2004/11/3
'************************************************************
Public Property Get Caption() As String
    Caption = lblColorButton.Caption
End Property

Public Property Let Caption(ByRef sNewValue As String)
    lblColorButton.Caption = sNewValue
End Property

'************************************************************
'vpeBFControlTipText
'vpeB̐F}EX̂Ƃɕ\镶
'X[G[F
'쐬ҁF
'쐬F2004/11/3
'************************************************************
Public Property Get ControlTipText() As String
    ControlTipText = lblColorButton.ControlTipText
End Property

Public Property Let ControlTipText(ByRef sNewValue As String)
    lblColorButton.ControlTipText = sNewValue
    lblColorButtonEffect.ControlTipText = sNewValue
End Property

'************************************************************
'vpeBFColorIndex
'vpeB̐F{^̐F
'X[G[F0-56ȊO̐w肵悤Ƃ
'쐬ҁF
'쐬F2004/11/3
'************************************************************
Public Property Get ColorIndex() As Long
    ColorIndex = m_ColorIndex
End Property

Public Property Let ColorIndex(ByVal lNewValue As Long)
    With lblColorButton
        Select Case lNewValue
            Case 0
                .BackStyle = fmBackStyleTransparent '{^̐F𓧖ɂ
                .BorderStyle = fmBorderStyleSingle
                m_ColorIndex = lNewValue
            Case 1 To 56
                If (ActiveWorkbook Is Nothing) Then 'ver1.3ǉ
                    Call Err.Raise(91, , "ANeBu[NubN擾鎖o܂łB")
                End If
                .BackStyle = fmBackStyleOpaque
                .BackColor = ActiveWorkbook.Colors(lNewValue)
                .BorderStyle = fmBorderStyleNone
                m_ColorIndex = lNewValue
            Case Else
                'sG[
                Call Err.Raise(380)
        End Select
    End With
End Property

'************************************************************
'\bhFlblColorButton_Click
'vpeB̐F{^ꂽ̏
'X[G[F
'쐬ҁF
'쐬F2004/11/3
'************************************************************
Private Sub lblColorButton_Click()
    With Me
        If Not .Locked Then
            .Value = Not .Value
        End If
    End With
End Sub

'************************************************************
'\bhFlblColorButtonEffect_Click
'vpeB̐F{^ꂽ̏
'X[G[F
'쐬ҁF
'쐬F2004/11/3
'************************************************************
Private Sub lblColorButtonEffect_Click()
    With Me
        If Not .Locked Then
            .Value = Not .Value
        End If
    End With
End Sub
